<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSeatAssignmentDetail ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSeatAssignmentDetail
 * @subpackage Arrays
 */
class ArrayOfSeatAssignmentDetail extends AbstractStructArrayBase
{
    /**
     * The SeatAssignmentDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SeatAssignmentDetail[]
     */
    public $SeatAssignmentDetail;
    /**
     * Constructor method for ArrayOfSeatAssignmentDetail
     * @uses ArrayOfSeatAssignmentDetail::setSeatAssignmentDetail()
     * @param \StructType\SeatAssignmentDetail[] $seatAssignmentDetail
     */
    public function __construct(array $seatAssignmentDetail = array())
    {
        $this
            ->setSeatAssignmentDetail($seatAssignmentDetail);
    }
    /**
     * Get SeatAssignmentDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SeatAssignmentDetail[]|null
     */
    public function getSeatAssignmentDetail()
    {
        return isset($this->SeatAssignmentDetail) ? $this->SeatAssignmentDetail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSeatAssignmentDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSeatAssignmentDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSeatAssignmentDetailForArrayConstraintsFromSetSeatAssignmentDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSeatAssignmentDetailSeatAssignmentDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfSeatAssignmentDetailSeatAssignmentDetailItem instanceof \StructType\SeatAssignmentDetail) {
                $invalidValues[] = is_object($arrayOfSeatAssignmentDetailSeatAssignmentDetailItem) ? get_class($arrayOfSeatAssignmentDetailSeatAssignmentDetailItem) : sprintf('%s(%s)', gettype($arrayOfSeatAssignmentDetailSeatAssignmentDetailItem), var_export($arrayOfSeatAssignmentDetailSeatAssignmentDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SeatAssignmentDetail property can only contain items of type \StructType\SeatAssignmentDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SeatAssignmentDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SeatAssignmentDetail[] $seatAssignmentDetail
     * @return \ArrayType\ArrayOfSeatAssignmentDetail
     */
    public function setSeatAssignmentDetail(array $seatAssignmentDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($seatAssignmentDetailArrayErrorMessage = self::validateSeatAssignmentDetailForArrayConstraintsFromSetSeatAssignmentDetail($seatAssignmentDetail))) {
            throw new \InvalidArgumentException($seatAssignmentDetailArrayErrorMessage, __LINE__);
        }
        if (is_null($seatAssignmentDetail) || (is_array($seatAssignmentDetail) && empty($seatAssignmentDetail))) {
            unset($this->SeatAssignmentDetail);
        } else {
            $this->SeatAssignmentDetail = $seatAssignmentDetail;
        }
        return $this;
    }
    /**
     * Add item to SeatAssignmentDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\SeatAssignmentDetail $item
     * @return \ArrayType\ArrayOfSeatAssignmentDetail
     */
    public function addToSeatAssignmentDetail(\StructType\SeatAssignmentDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SeatAssignmentDetail) {
            throw new \InvalidArgumentException(sprintf('The SeatAssignmentDetail property can only contain items of type \StructType\SeatAssignmentDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SeatAssignmentDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SeatAssignmentDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SeatAssignmentDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SeatAssignmentDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SeatAssignmentDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SeatAssignmentDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SeatAssignmentDetail
     */
    public function getAttributeName()
    {
        return 'SeatAssignmentDetail';
    }
}
