<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTrainSeatAssignmentDetail ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTrainSeatAssignmentDetail
 * @subpackage Arrays
 */
class ArrayOfTrainSeatAssignmentDetail extends AbstractStructArrayBase
{
    /**
     * The TrainSeatAssignmentDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TrainSeatAssignmentDetail[]
     */
    public $TrainSeatAssignmentDetail;
    /**
     * Constructor method for ArrayOfTrainSeatAssignmentDetail
     * @uses ArrayOfTrainSeatAssignmentDetail::setTrainSeatAssignmentDetail()
     * @param \StructType\TrainSeatAssignmentDetail[] $trainSeatAssignmentDetail
     */
    public function __construct(array $trainSeatAssignmentDetail = array())
    {
        $this
            ->setTrainSeatAssignmentDetail($trainSeatAssignmentDetail);
    }
    /**
     * Get TrainSeatAssignmentDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TrainSeatAssignmentDetail[]|null
     */
    public function getTrainSeatAssignmentDetail()
    {
        return isset($this->TrainSeatAssignmentDetail) ? $this->TrainSeatAssignmentDetail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTrainSeatAssignmentDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTrainSeatAssignmentDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTrainSeatAssignmentDetailForArrayConstraintsFromSetTrainSeatAssignmentDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTrainSeatAssignmentDetailTrainSeatAssignmentDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfTrainSeatAssignmentDetailTrainSeatAssignmentDetailItem instanceof \StructType\TrainSeatAssignmentDetail) {
                $invalidValues[] = is_object($arrayOfTrainSeatAssignmentDetailTrainSeatAssignmentDetailItem) ? get_class($arrayOfTrainSeatAssignmentDetailTrainSeatAssignmentDetailItem) : sprintf('%s(%s)', gettype($arrayOfTrainSeatAssignmentDetailTrainSeatAssignmentDetailItem), var_export($arrayOfTrainSeatAssignmentDetailTrainSeatAssignmentDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TrainSeatAssignmentDetail property can only contain items of type \StructType\TrainSeatAssignmentDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TrainSeatAssignmentDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TrainSeatAssignmentDetail[] $trainSeatAssignmentDetail
     * @return \ArrayType\ArrayOfTrainSeatAssignmentDetail
     */
    public function setTrainSeatAssignmentDetail(array $trainSeatAssignmentDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($trainSeatAssignmentDetailArrayErrorMessage = self::validateTrainSeatAssignmentDetailForArrayConstraintsFromSetTrainSeatAssignmentDetail($trainSeatAssignmentDetail))) {
            throw new \InvalidArgumentException($trainSeatAssignmentDetailArrayErrorMessage, __LINE__);
        }
        if (is_null($trainSeatAssignmentDetail) || (is_array($trainSeatAssignmentDetail) && empty($trainSeatAssignmentDetail))) {
            unset($this->TrainSeatAssignmentDetail);
        } else {
            $this->TrainSeatAssignmentDetail = $trainSeatAssignmentDetail;
        }
        return $this;
    }
    /**
     * Add item to TrainSeatAssignmentDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\TrainSeatAssignmentDetail $item
     * @return \ArrayType\ArrayOfTrainSeatAssignmentDetail
     */
    public function addToTrainSeatAssignmentDetail(\StructType\TrainSeatAssignmentDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TrainSeatAssignmentDetail) {
            throw new \InvalidArgumentException(sprintf('The TrainSeatAssignmentDetail property can only contain items of type \StructType\TrainSeatAssignmentDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TrainSeatAssignmentDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TrainSeatAssignmentDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TrainSeatAssignmentDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TrainSeatAssignmentDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TrainSeatAssignmentDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TrainSeatAssignmentDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TrainSeatAssignmentDetail
     */
    public function getAttributeName()
    {
        return 'TrainSeatAssignmentDetail';
    }
}
