<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Train ServiceType
 * @subpackage Services
 */
class Train extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named TrainSeatAssignment
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\TrainSeatAssignment $parameters
     * @return \StructType\TrainSeatAssignmentResponse|bool
     */
    public function TrainSeatAssignment(\StructType\TrainSeatAssignment $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->TrainSeatAssignment($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\TrainSeatAssignmentResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
